from twitch_python_wrapper.api.client import APIClient


class Moderation:
    def __init__(self, client: APIClient):
        self.client = client

    def check_automod_status(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#check-automod-status>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def manage_held_automod_messages(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#manage-held-automod-messages>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_automod_settings(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-automod-settings>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def update_automod_settings(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#update-automod-settings>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_banned_users(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-banned-users>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def ban_user(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#ban-user>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def unban_user(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#unban-user>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_unban_requests(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-unban-requests>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def resolve_unban_requests(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#resolve-unban-requests>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_blocked_terms(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-blocked-terms>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def add_blocked_terms(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#add-blocked-term>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def remove_blocked_term(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#remove-blocked-term>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def delete_chat_messages(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#delete-chat-messages>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_moderated_channels(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-moderated-channels>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_moderators(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-moderators>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def add_channel_moderator(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#add-channel-moderator>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def remove_channel_moderator(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#remove-channel-moderator>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_vips(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-vips>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def add_channel_vip(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#add-channel-vip>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def remove_channel_vip(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#remove-channel-vip>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def update_shield_mode_status(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#update-shield-mode-status>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def get_shield_mode_status(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#get-shield-mode-status>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")

    def warn_chat_user(self):
        """
        `Twitch API Reference <https://dev.twitch.tv/docs/api/reference/#warn-chat-user>`_

        :raise NotImplementedError: This feature is not implemented yet.
        """

        raise NotImplementedError("Not Implemented Yet")
